<template>
    <div class="card poke-card text-center">
        <img :src="cardData.image_url" class="poke-img" alt="Pokemon Image">
        <div class="card-body">
            <h5 class="card-title poke-name">{{ cardData.name.toUpperCase() }}</h5>
            <h6>{{ cardData.type }}</h6>
        </div>
        <div class="card-footer poke-footer-actions">
            <div class="row">
                <div class="col-md-6" style="text-align: left;">
                    <button @click="this.$emit('pokemon-card-liked', cardData)" class="btn btn-primary poke-action like">
                        <i class="fa fa-thumbs-o-up" aria-hidden="true"></i> Like
                    </button>
                </div>
                <div class="col-md-6" style="text-align: right;">
                    <button @click="this.$emit('pokemon-card-disliked', cardData)" class="btn btn-primary poke-action">
                        <i class="fa fa-thumbs-o-down" aria-hidden="true"></i> Hate
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: "PokemonCard",
    data() {
        return {
            cardData: Object,
        }
    },
    props: {
        pokemon: JSON,
        imageUrl: String,
        baseUrl: String,
    },
    async created() {
        const res = await fetch(`${this.baseUrl}/pokemon/${this.pokemon}`)
        const details = await res.json()
        let rawTypeArray = details.types;
        let types = [];

        rawTypeArray.forEach(index => {
            types.push(index.type.name)
        });
        this.cardData = {
            name: this.pokemon,
            type: types.join(" | "),
            image_url: this.imageUrl + details.id + '.svg'
        }
    },
    emits: [
        "pokemon-card-liked",
        "pokemon-card-disliked"
    ]
}
</script>